<template>
    <v-layout>
        <v-flex xs12>
           <!-- <v-card class="mb-2" color="white">
                <v-toolbar color="blue lighten-3" dark height="50px">
                    <v-toolbar-title>LAPORAN</v-toolbar-title>
                    <v-spacer></v-spacer>
                </v-toolbar>
                <v-layout row style="background:white">
                    <v-flex xs5>
                        <v-textarea class="ma-1" style="font-size:14px" rows="1" outline label="LAPORAN INA BARU" v-model="new_report"></v-textarea>
                    </v-flex>
                    <v-flex xs5>
                        <v-textarea class="ma-1" style="font-size:14px" rows="1" outline label="LAPORAN ENG BARU" v-model="new_reportname"></v-textarea>
                    </v-flex>
                    <v-flex xs2>
                        <span title="tambahkan saran baru" @click="insertNewReport()" class="icon-medium-fill-base xs1 white--text primary  ml-1 icon-add"></span>
                    </v-flex>
                </v-layout>
                <v-divider></v-divider>
            </v-card> -->
            <v-card class="mb-2" color="white">
                <v-toolbar color="blue lighten-3" dark height="50px">
                    <v-toolbar-title>DAFTAR LAPORAN</v-toolbar-title>
                    <v-spacer></v-spacer>
                </v-toolbar>
                <v-layout row style="background:white">
                <v-text-field class=" xs4 ma-1" label="Grup" placeholder="Cari..." outline v-model="reportgroup" @keyup.enter="searchReport()"></v-text-field>
                    <v-text-field class=" xs4 ma-1" label="Kode" placeholder="Cari..." outline v-model="reportcode" @keyup.enter="searchReport()"></v-text-field>
                    <v-text-field class=" xs4 ma-1" label="Nama" placeholder="Cari..." outline v-model="reportname" @keyup.enter="searchReport()"></v-text-field>
                    <v-select item-text="M_StatusName" return-object :items="f_statuss" style="font-size:14px" class="xs4 mini-select ma-1" v-model="selected_filter_status"
                        outline hide-details label="Status"></v-select>
                </v-layout>
                <v-divider></v-divider>
                <v-layout row wrap class="scroll-container" style="max-height:600px;overflow: auto;">
                    <v-flex xs12 pl-2 pr-2 pt-2 pb-2>
                        <v-data-table :headers="headers" :items="reports" :loading="isLoading" hide-actions class="elevation-1">
                            <template slot="items" slot-scope="props">
                            <td class="text-xs-left pa-2" @click="selectMe(props.item)" v-html="props.item.R_ReportGroupName">
                                </td>
                                <td class="text-xs-left pa-2" @click="selectMe(props.item)" v-html="props.item.R_ReportCode">
                                </td>
                                <td class="text-xs-left pa-2" @click="selectMe(props.item)" v-html="props.item.R_ReportName">
                                </td>
                                <td class="text-xs-left pa-2" @click="selectMe(props.item)">
                                    <div>
                                        <v-btn @click="changeBtnFlag(props.item)" v-if="props.item.status === 'N'" small color="error">
                                            <v-icon left>close</v-icon> Belum dipilih</v-btn>
                                        <v-btn @click="changeBtnFlag(props.item)" v-if="props.item.status === 'Y'" small color="success">
                                            <v-icon left>check</v-icon> Sudah terpilih</v-btn>
                                    </div>
                                </td>
                            </template>
                        </v-data-table>
                    </v-flex>
                </v-layout>
                <v-divider></v-divider>
                <v-pagination style="margin-top:10px;margin-bottom:10px" v-model="curr_page" :length="xtotal_page"></v-pagination>

                <template>
                    <v-layout row justify-center>
                        <v-dialog v-model="dialogreport" persistent max-width="750px">
                            <v-card>
                                <v-card-title>
                                    <span class="headline">FORM LAPORAN</span>
                                </v-card-title>
                                <v-card-text class="pt-0 pb-0">
                                    <v-form ref="formuserreport" v-model="validreport" lazy-validation>
                                        <v-layout wrap>
                                            <v-flex xs12>
                                                <v-autocomplete label="Kelompok Hasil*" v-model="xautouser" :items="xautousers" :search-input.sync="search_user"
                                                    auto-select-first no-filter item-text="Group_ResultName" return-object no-data-text="Cari GroupResult"
                                                    small :rules="userRules" required>
                                                    <template slot="item" slot-scope="{ item }">
                                                        <v-list-tile-content>
                                                            <v-list-tile-title v-text="item.Group_ResultName"></v-list-tile-title>
                                                        </v-list-tile-content>
                                                    </template>
                                                </v-autocomplete>
                                            </v-flex>
                                            <v-flex xs12 pa-2>
                                                <v-autocomplete label="Pemeriksaan*" v-model="xautotest" :items="xautotests" :search-input.sync="search_test" auto-select-first
                                                    no-filter item-text="T_TestName" return-object no-data-text="Cari Pemeriksaan"
                                                    small>
                                                    <template slot="item" slot-scope="{ item }">
                                                        <v-list-tile-content>
                                                            <v-list-tile-title v-text="item.T_TestName"></v-list-tile-title>
                                                        </v-list-tile-content>
                                                    </template>
                                                </v-autocomplete>
                                            </v-flex>
                                            <v-flex>
                                                <p v-for="(xerror,idx) in xerrors" class="error pl-2 pr-2" style="color:#fff">{{xerror.msg}}</p>
                                            </v-flex>
                                        </v-layout>
                                </v-card-text>
                                <v-card-actions>
                                    <v-spacer></v-spacer>
                                    <v-btn color="blue darken-1" flat @click="updateDialogFormReport()">Tutup</v-btn>
                                    <v-btn color="blue darken-1" flat @click="saveFormReport()">Simpan</v-btn>
                                </v-card-actions>
                                </v-form>
                            </v-card>
                        </v-dialog>
                    </v-layout>
                </template>

            </v-card>
        </v-flex>

        <one-dialog-print :title="printtitle" :width="printwidth" :height="500" :status="openprint" :urlprint="urlprint" @close-dialog-print="closePrint"></one-dialog-print>
        <template>

            <v-dialog v-model="dialogdeletealertreport" max-width="30%">
                <v-card>
                    <v-card-title class="headline grey lighten-2 pt-2 pb-2" primary-title>
                        Peringatan !
                    </v-card-title>
                    <v-card-text class="pt-2 pb-2">
                        <v-layout row>
                            <v-flex xs12 d-flex>
                                <v-layout row>
                                    <v-flex pb-1 xs12>
                                        <v-layout row>
                                            <v-flex pt-2 pr-2 xs12>
                                                {{msgalertreport}}
                                            </v-flex>
                                        </v-layout>
                                    </v-flex>
                                </v-layout>
                            </v-flex>
                        </v-layout>
                    </v-card-text>
                    <v-divider></v-divider>
                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn color="primary" flat @click="dialogdeletealertreport = false">
                            Tutup
                        </v-btn>
                        <v-btn color="primary" flat @click="closeDeleteAlertReport()">
                            Yakin lah
                        </v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>

        </template>

    </v-layout>
</template>

<style scoped>
    .searchbox .v-input.v-text-field .v-input__slot {
        min-height: 60px;
    }

    .searchbox .v-btn {
        min-height: 60px;
    }

    table.v-table tbody td,
    table.v-table tbody th {
        height: 40px;
    }

    table.v-table thead tr {
        height: 40px;
    }

    .textinput {
        -webkit-transition: width 0.4s ease-in-out;
        transition: width 0.4s ease-in-out;
        background-color: white;
        background-position: 10px 10px;
        background-repeat: no-repeat;
        padding-left: 40px;
        width: 100%;
        padding: 8px 10px;
        margin-bottom: 5px;
        box-sizing: border-box;
        border: 1px solid #607d8b;

    }

    .textinput:focus {
        width: 100%;
    }

    .textinput:focus::-webkit-input-placeholder {
        color: transparent;
    }

    .textinput:focus::-moz-placeholder {
        color: transparent;
    }

    .textinput:-moz-placeholder {
        color: transparent;
    }

    .boxoutline {
        color: red;
        border: 1px solid red;
        justify-content: center;
        height: 45px;
        line-height: 45px;
        padding-left: 10px;
        background: #ffffff;
        font-size: 14px;
        font-weight: 500;
        border-radius: 1px
    }

    .boxoutline:hover {
        background: rgba(0, 0, 0, 0.07) !important;
        font-size: 15px;
        font-weight: 700;
    }

    .boxsolid {
        color: #ffffff;
        border: 1px solid #ffffff;
        justify-content: center;
        height: 45px;
        line-height: 45px;
        padding-left: 10px;
        background: #f44336;
        font-size: 14px;
        font-weight: 500;
        border-radius: 1px
    }

    .boxsolid:hover {
        background: #f44336de;
        font-size: 15px;
        font-weight: 700;
    }

    .scroll-container {
        scroll-padding: 50px 0 0 50px;
    }

    ::-webkit-scrollbar {
        width: 7px;
    }

    /* this targets the default scrollbar (compulsory) */

    ::-webkit-scrollbar-track {
        background-color: #73baf3;
    }

    /* the new scrollbar will have a flat appearance with the set background color */

    ::-webkit-scrollbar-thumb {
        background-color: #2196f3;
    }

    /* this will style the thumb, ignoring the track */

    ::-webkit-scrollbar-button {
        background-color: #0079da;
    }

    /* optionally, you can style the top and the bottom buttons (left and right for horizontal bars) */

    ::-webkit-scrollbar-corner {
        background-color: black;
    }

    /* if both the vertical and the horizontal bars appear, then perhaps the right bottom corner also needs to be styled */
</style>

<script>
    module.exports = {
        components: {
            'one-date-picker': httpVueLoader('../../common/oneDatePicker.vue'),
            'one-dialog-print': httpVueLoader('../../common/oneDialogPrintX.vue')
        },
        data() {
            return {
                query: "",
                items: [],
                openprint: false,
                urlprint: '',
                printtitle: '',
                printwidth: 600,
                formatreport: 'pdf',
                readonlydefault: false,
                page: 1,
                search_user: '',
                search_test: '',
                userRules: [
                    v => !!v || 'GroupResult harus dipilih'
                ],
                testRules: [
                    v => !!v || 'Pemeriksaan harus dipilih'
                ],
                headers: [{
                        text: "GRUP LAPORAN",
                        align: "left",
                        sortable: false,
                        value: "name",
                        width: "20%",
                        class: "blue lighten-3 white--text"
                    },
                    {
                        text: "KODE LAPORAN",
                        align: "left",
                        sortable: false,
                        value: "name",
                        width: "10%",
                        class: "blue lighten-3 white--text"
                    },
                    {
                        text: "NAMA LAPORAN",
                        align: "left",
                        sortable: false,
                        value: "name",
                        width: "30%",
                        class: "blue lighten-3 white--text"
                    },
                    {
                        text: "STATUS",
                        align: "left",
                        sortable: false,
                        value: "name",
                        width: "10%",
                        class: "blue lighten-3 white--text"
                    }
                ],
                pagination: {
                    descending: false,
                    page: 1,
                    rowsPerPage: 100,
                    sortBy: 'Group_ResultReportName ASC',
                    totalItems: this.$store.state.report.total_transactions
                },
                statuss: [{
                        waktu: '16-07-2019 10:00',
                        status: 'Order Dibuat',
                        report: 'Nagita Slavina'
                    },
                    {
                        waktu: '16-07-2019 11:00',
                        status: 'Order Dikirim',
                        report: 'Nagita Slavina'
                    },
                    {
                        waktu: '16-07-2019 12:00',
                        status: 'Order dikonfirmasi',
                        report: 'Chacha Frederica'
                    },
                    {
                        waktu: '16-07-2019 13:00',
                        status: 'Telah dibuat Surat Jalan',
                        report: 'Chacha Frederica'
                    },
                    {
                        waktu: '16-07-2019 14:00',
                        status: 'Kurir akan mengambil sampel',
                        report: 'Satria Subiantoro'
                    }
                ],
                color: "success",
                validreport: false,
                xid: 0,
                isinput: "N",
                countprice: 0,
                reportreportid: 0,
                reportxname: "",
                reportlang: "",
                reporttext: "",
                isadvance: "N",
                reportformatadvance: "",
                issenttouser: "N",
                menustartdate: false,
                menuenddate: false,
                date: new Date().toISOString().substr(0, 10),

                dialogdeletealertreport: false,
                dialogverifyalertreport: false,
                dialogreleasealertreport: false,
                alertverify: false,
                dialogunreleasealertreport: false,
                dialogunverifyalertreport: false,
                msgalertreport: ""
            };
        },
        mounted() {},
        computed: {
            selected_filter_status: {
                get() {
                    return this.$store.state.report.selected_filter_status
                },
                set(val) {
                    this.$store.commit("report/update_selected_filter_status", val)
                    this.searchReport()
                }
            },
            f_statuss: {
                get() {
                    return this.$store.state.report.f_statuss
                },
                set(val) {
                    this.$store.commit("report/update_f_statuss", val)
                }
            },
            reports() {
                return this.$store.state.report.reports
            },
            xuser() {
                return this.$store.state.user.selected_user
            },
            dialogreport() {
                return this.$store.state.report.dialog_form_report
            },
            xerrors() {
                return this.$store.state.report.errors
            },
            isLoading() {
                return this.$store.state.report.search_status == 1
            },
            startComputedDateFormatted() {
                return this.formatDate(this.xstartdate)
            },
            xstartdate: {
                get() {
                    return this.$store.state.report.startdate
                },
                set(val) {
                    this.$store.commit("report/update_startdate", val)
                }
            },
            endComputedDateFormatted() {
                return this.formatDate(this.xenddate)
            },
            xenddate: {
                get() {
                    return this.$store.state.report.enddate
                },
                set(val) {
                    this.$store.commit("report/update_enddate", val)
                }
            },
            xautotests() {
                return this.$store.state.report.autotests
            },
            xautotest: {
                get() {
                    return this.$store.state.report.autotest
                },
                set(val) {
                    this.$store.commit("report/update_autotest", val)
                }
            },
            xstatuss() {
                return this.$store.state.report.statuss
            },
            dialogstatusorder() {
                return this.$store.state.report.dialog_status_order
            },
            xautousers() {
                return this.$store.state.report.autousers
            },
            xautouser: {
                get() {
                    return this.$store.state.report.autouser
                },
                set(val) {
                    this.$store.commit("report/update_autouser", val)
                }
            },
            xsearch: {
                get() {
                    return this.$store.state.report.x_search
                },
                set(val) {
                    this.$store.commit("report/update_x_search", val)
                }
            },
            reportgroup: {
                get() {
                    return this.$store.state.report.reportgroup
                },
                set(val) {
                    this.$store.commit("report/update_reportgroup", val)
                }
            },
            reportcode: {
                get() {
                    return this.$store.state.report.reportcode
                },
                set(val) {
                    this.$store.commit("report/update_reportcode", val)
                }
            },
            reportname: {
                get() {
                    return this.$store.state.report.reportname
                },
                set(val) {
                    this.$store.commit("report/update_reportname", val)
                }
            },
            curr_page: {
                get() {
                    return this.$store.state.report.current_page
                },
                set(val) {
                    this.$store.commit("report/update_current_page", val)
                    this.$store.dispatch("report/lookup", {
                        id: this.xuser.name === "" ? "0" : this.$store.state.user.selected_user
                            .id,
                        reportgroup: this.reportgroup,
                        reportcode: this.reportcode,
                        reportname: this.reportname,
                        status: this.selected_filter_status.M_StatusID,
                        current_page: val,
                        lastid: -1
                    })
                }
            },
            xtotal_page: {
                get() {
                    return this.$store.state.report.total_data
                },
                set(val) {
                    this.$store.commit("report/update_total_data", val)
                }
            },
            value_report: {
                get() {
                    return this.$store.state.report.value_report
                },
                set(val) {
                    this.$store.commit("report/update_value_report", val)
                }
            },
            new_report: {
                get() {
                    return this.$store.state.report.new_report
                },
                set(val) {
                    this.$store.commit("report/update_new_report", val)
                }
            },
            new_reportname: {
                get() {
                    return this.$store.state.report.new_reportname
                },
                set(val) {
                    this.$store.commit("report/update_new_reportname", val)
                }
            },
        },
        methods: {
            isSelected(p) {
                return p.id == this.$store.state.report.selected_report.id
            },
            selectMe(sc) {
                this.$store.commit("report/update_selected_report", sc)

            },
            updateDialogFormReport() {
                this.$store.commit("report/update_dialog_form_report", false)
            },
            updateDialogStatusOrder() {
                this.$store.commit("report/update_dialog_status_order", false)
            },
            setStatusOrder(val) {
                this.$store.commit("report/update_reports", {})
                this.$store.commit("report/update_dialog_status_order", true)
                this.$store.commit("report/update_statuss", val.statuss)
            },
            doPriceList(val) {
                console.log(location)
                var id = val.id
                location.replace("/one-ui/user/vuex/one-md-price/" + "?id=" + id)
            },
            doPrice() {
                console.log(location)
                var id = this.xid
                location.replace("/one-ui/user/vuex/one-md-price/" + "?id=" + id)
            },
            thr_search_user: _.debounce(function () {
                this.$store.dispatch("report/searchuser", {
                    tes: this.search_user
                })
            }, 200),
            thr_search_test: _.debounce(function () {
                this.$store.dispatch("report/searchtest", {
                    search: this.search_test
                })
            }, 200),
            thr_search: _.debounce(function () {
                this.$store.dispatch("user/lookupbyname", {
                    user: this.$store.state.user.x_search,
                    report: this.xsearch,
                    current_page: 1,
                    lastid: -1
                })
                this.$store.dispatch("report/lookup", {
                    user: this.xuser.name === "" ? "0" : this.$store.state.user.selected_user
                        .id,
                    reportgroup: this.reportgroup,
                    reportcode: this.reportcode,
                    reportname: this.reportname,
                    status: this.selected_filter_status.M_StatusID,
                    current_page: 1,
                    lastid: -1
                })
            }, 200),
            searchReport() {
                this.$store.dispatch("report/lookup", {
                    id: this.xuser.name === "" ? "0" : this.$store.state.user.selected_user
                        .id,
                        reportgroup: this.reportgroup,
                    reportcode: this.reportcode,
                    reportname: this.reportname,
                    status: this.selected_filter_status.M_StatusID,
                    current_page: 1,
                    lastid: -1
                })
            },
            doPrint() {
                console.log('doprint')
                this.printwidth = 1028
                this.printtitle = ""
                let report = one_report()
                var id = this.xid
                var d = new Date();
                var n = d.getTime()
                var rptname = 'user_price'
                var formatrpt = this.formatreport

                this.urlprint = "/birt/run?__report=report/one/md/" + rptname +
                    ".rptdesign&__format=" +
                    formatrpt + "&PReportID=" + id + "&reportxname=" + report.Group_ResultReportReportname +
                    "&tm=" + n

                this.openprint = true
            },
            closePrint() {
                this.openprint = false
            },
            changeDetail(value) {
                var details = this.$store.state.report.reports
                var idx = _.findIndex(details, function (o) {
                    return o.Nat_NormalValueID == value.Nat_NormalValueID && o.Nat_ReportUserID ==
                        value.Nat_ReportUserID
                })
                details[idx].Nat_ReportUserReportIna = value.Nat_ReportUserReportIna
                details[idx].Nat_ReportUserReportEng = value.Nat_ReportUserReportEng
                this.$store.commit("report/update_reports", details)
            },
            savedetail() {
                var prm = {
                    details: this.$store.state.report.reports
                }
                this.$store.dispatch("report/saveallreportdetail", prm)
            },
            insertNewReport() {
                var prm = {
                    xid: 0,
                    userid: this.$store.state.user.selected_user.id,
                    reportgroup: this.reportgroup,
                    reportcode: this.new_report,
                    reportname: this.new_reportname,
                    filterstatus: this.selected_filter_status.M_StatusID,
                    current_page: this.curr_page
                }
                this.$store.dispatch("report/save", prm)
                this.new_report = ''
                this.new_reportname = ''
            },
            saveReportNew() {
                var prm = {
                    id: 0,
                    value: this.value_new_report,
                    valueeng: this.new_reportname
                }
                this.$store.dispatch("report/savelistingreport", prm)
            },
            changeBtnFlag(value) {
                var newval = value.status === 'N' ? 'Y' : 'N'
                var prm = value
                prm.status = newval
                prm.name = value.R_ReportName
                prm.userid = this.$store.state.user.selected_user.id
                prm.reportcode = this.reportcode
                prm.reportname = this.reportname
                prm.filterstatus = this.selected_filter_status.M_StatusID
                prm.current_page = this.curr_page
                
                this.$store.dispatch("report/saveaddeditreport", prm)
            },
            openFormReport(val) {
                this.xid = val
                this.$store.commit("report/update_autotests", [])
                this.$store.commit("report/update_autotest", {})
                this.$store.commit("report/update_dialog_form_report", true)
            },
            editFormReport(val) {
                this.xid = val.id
                this.$store.commit("report/update_autousers", [{
                    Group_ResultID: val.Group_ResultID,
                    Group_ResultName: val.Group_ResultName
                }])
                this.$store.commit("report/update_autouser", {
                    Group_ResultID: val.Group_ResultID,
                    Group_ResultName: val.Group_ResultName
                })

                this.$store.commit("report/update_autotests", [{
                    T_TestID: val.T_TestID,
                    T_TestName: val.T_TestName
                }])
                this.$store.commit("report/update_autotest", {
                    T_TestID: val.T_TestID,
                    T_TestName: val.T_TestName
                })
                this.$store.commit("report/update_dialog_form_report", true)
            },
            checkError(value) {
                var errors = this.$store.state.report.errors
                if (errors.includes(value)) {
                    return true
                } else {
                    return false
                }
            },
            saveFormReport() {
                if (this.$refs.formuserreport.validate()) {
                    this.$store.dispatch("report/save", {
                        xid: this.xid,
                        userid: this.xautouser ? this.$store.state.report.autouser.Group_ResultID :
                            0,
                        username: this.$store.state.report.autouser.Group_ResultName,
                        testid: this.xautotest ? this.$store.state.report.autotest.T_TestID : 0,
                        testname: this.xautotest ? this.$store.state.report.autotest.T_TestName : '',
                        suser: this.$store.state.user.x_search,
                        sreport: this.xsearch
                    })
                }

            },
            set_date2(x) {
                this.startdate = x.new_date
            },
            set_date3(x) {
                this.enddate = x.new_date
            },
            formatDate(date) {
                if (!date) return null

                const [year, month, day] = date.split('-')
                return `${day}-${month}-${year}`
            },
            deFormatedDate(date) {
                if (!date) return null

                const [day, month, year] = date.split('-')
                return `${year}-${month.padStart(2, '0')}-${day.padStart(2, '0')}`
            },
            updateAlert_success(val) {
                this.$store.commit("user/update_alert_success", val)
            },
            deleteFormReport(data) {
                this.xid = data.id

                this.msgalertreport = "Yakin, mau hapus report ini?"
                this.dialogdeletealertreport = true
            },
            closeDeleteAlertReport() {
                this.$store.dispatch("report/delete", {
                    xid: this.xid,
                    userid: this.$store.state.report.autouser.Group_ResultID,
                    username: this.$store.state.report.autouser.Group_ResultName,
                    testid: this.xautotest ? this.$store.state.report.autotest.T_TestID : 0,
                    testname: this.xautotest ? this.$store.state.report.autotest.T_TestName : '',
                    suser: this.$store.state.user.x_search,
                    sreport: this.xsearch
                })
                this.dialogdeletealertreport = false
            }
        },
        watch: {
            xsearch(val, old) {
                console.log(val)
                this.xsearch = val
                this.thr_search()

            },
            search_user(val, old) {
                if (val == old) return
                if (!val) return
                if (val.length < 1) return
                if (this.$store.state.report.update_autocomplete_status == 1) return
                this.thr_search_user()
            },
            search_test(val, old) {
                if (val == old) return
                if (!val) return
                if (val.length < 1) return
                if (this.$store.state.report.update_autocomplete_status == 1) return
                this.thr_search_test()
            }
        }
    }
</script>